#ifndef BatchLab_ArrayFactory_h
#define BatchLab_ArrayFactory_h

// Inheritance :
#include <BatchLab/Core/BaseFactory.h>
#include <Slash/Data/IArrayFactory.h>

namespace Slash {namespace Core {class IWriter;}}

namespace Slash {namespace Store {class ITree;}}

namespace BatchLab {

class ArrayFactory 
: public BaseFactory
,public virtual Slash::Data::IArrayFactory 
{
public: //Slash::Data::IArrayFactory
  virtual Slash::Data::IArray* create(const std::string&,const std::string&,
                                const std::vector<unsigned int>&,
                                const std::string& = "");
  //virtual bool destroy(AIDA::Slash::Data::IArray*);
  virtual Slash::Data::IArray* add(const std::string&,const Slash::Data::IArray&,const Slash::Data::IArray&,const std::string& = "");
  virtual Slash::Data::IArray* subtract(const std::string&,const Slash::Data::IArray&,const Slash::Data::IArray&,const std::string& = "");
  virtual Slash::Data::IArray* multiply(const std::string&,const Slash::Data::IArray&,const Slash::Data::IArray&,const std::string& = "");
  virtual Slash::Data::IArray* divide(const std::string&,const Slash::Data::IArray&,const Slash::Data::IArray&,const std::string& = "");
  virtual Slash::Data::IArray* add(const std::string&,const Slash::Data::IArray&,double,const std::string& = "");
  virtual Slash::Data::IArray* multiply(const std::string&,const Slash::Data::IArray&,double,const std::string& = "");
public:
  ArrayFactory(Slash::Core::IWriter&,Slash::Store::ITree&);
  virtual ~ArrayFactory();
};

}

#endif
