#ifndef BatchLab_BaseFolder_h
#define BatchLab_BaseFolder_h

// Inheritance :
#include <Slash/Store/IFolder.h>

#include <string>
#include <list>

namespace Slash {namespace Core {class IWriter;}}

namespace BatchLab {

class BaseFolder : public virtual Slash::Store::IFolder {
public: //Slash::Store::IFolder
  virtual Slash::Store::IFolder* parent() const;
  virtual std::string name() const;
  virtual void setName(const std::string&);
  virtual Slash::Store::IObject* findInTree(const std::string&,Slash::Store::IFolder*&) const;
  virtual Slash::Store::IObject* findObject(const std::string&) const;
  virtual bool isValid(const Slash::Store::IObject*) const;
  virtual Slash::Store::IFolder* findFolder(const std::string&) const;
  virtual unsigned int numberOfObjects() const;
  virtual unsigned int numberOfFolders() const;
  virtual void ls(bool) const;
  virtual std::string path() const;
  virtual bool visit(Slash::Store::IFolderVisitor&) const;
  virtual void setParent(Slash::Store::IFolder*);
  virtual void setLinkingFolder(Slash::Store::IFolder*);
  virtual Slash::Store::IFolder* linkingFolder() const;
  virtual std::string linkingPath() const;

  virtual Slash::Store::ITree& tree();
public:
  BaseFolder(Slash::Core::IWriter&,Slash::Store::IFolder*,const std::string&,Slash::Store::ITree&);
  virtual ~BaseFolder();
  std::string hierarchy(const std::string& = "") const; 
protected:
  Slash::Core::IWriter& fPrinter;
  Slash::Store::IFolder* fParent;
  std::string fName;
  Slash::Store::ITree& fTree;
  Slash::Store::IFolder* fLinkingFolder;
};

}

#endif
