#ifndef BatchLab_XML_WriteContext_h
#define BatchLab_XML_WriteContext_h

#include <string>

namespace Slash {namespace Core {class IWriter;}}

namespace Lib {
  class Out;
}

namespace BatchLab {

namespace XML {

class WriteContext {
public:
  WriteContext(Slash::Core::IWriter&,
                   Lib::Out&,
                   const std::string&,
                   const std::string&,
                   int = 0);
  virtual ~WriteContext();
public:
  Slash::Core::IWriter& printer() const;
  Lib::Out& out() const;
  const std::string& path() const;
  const std::string& name() const;
  int shift() const;
private:
  Slash::Core::IWriter& fPrinter;
  Lib::Out& fOut;
  std::string fPath;
  std::string fName;
  int fShift;
};

} //XML

} //BatchLab

#endif
