#ifndef Lib_DLL_h
#define Lib_DLL_h

namespace Slash {namespace Core {class IWriter;}}
#include <string>

namespace Lib {

typedef void (*Procedure)();

class DLL {
public:
  static bool isValid(const std::string&,Slash::Core::IWriter&);
public:
  DLL(const std::string&,Slash::Core::IWriter&,int = 0,bool = false);
  virtual ~DLL();
  bool open();
  Procedure findProcedure(const std::string&) const;
  void execute(const std::string&);
  const std::string& fileName() const;
  bool isOpened() const;
protected:
  void* fModule;
  Slash::Core::IWriter& fPrinter;
  std::string fName;
  std::string fDLL;
  int fVerboseLevel;
  std::string fError;
};

}

#endif




