#ifndef Lib_Session_h
#define Lib_Session_h

#include <Slash/Core/ISession.h>

#include <vector>

namespace Lib {

class Session : public virtual Slash::Core::ISession {
public: //Slash::Core::ISession
  virtual std::string name() const;
  virtual void addManager(Slash::Core::IManager*);
  virtual void removeManager(Slash::Core::IManager*);
  virtual Slash::Core::IManager* findManager(const std::string&) const;
  virtual void destroyManager(const std::string&);
  virtual Slash::Core::IWriter& printer();
  virtual bool load(const std::string&,const std::string&);
  virtual void redirectOutput(bool);
  virtual bool setParameter(const std::string&,const std::string&);
  virtual bool parameterValue(const std::string&,std::string&);
  virtual std::vector<std::string> availableParameters() const;
  virtual void flush();
  virtual void setVerboseLevel(int);
  virtual int verboseLevel() const;
  virtual unsigned int numberOfManagers() const;
  virtual const Slash::Core::IManager* manager(unsigned int) const;
  virtual std::vector<std::string> managerNames() const;
  virtual std::vector< std::pair<std::string,std::string> > arguments() const;
public:
  Session(Slash::Core::IWriter&);
  virtual ~Session();
  void setArguments(const std::vector< std::pair<std::string,std::string> >&);
private:
  std::vector<Slash::Core::IManager*> fManagers;
  Slash::Core::IWriter& fPrinter;
  int fVerboseLevel;
  std::vector< std::pair<std::string,std::string> > fArguments;
  std::string fName;
};

}

#endif
