#
# Visualize a cube with an Inventor SoCube node.
#
# This script could be executed on an OnX Python callback ;
# for example on a MenuItem with :
#    <activate exec="Python">import OnX;OnX.x('OnX_exa_cube')</activate>
# or from the OnX UI Python prompt with :
#   Python> import OnX_exa_cube
# or from the python shell with :
#       OS> <setup OnX>
#       OS> <start Python>
#       >>> import OnX_exa_cube
#

import OnX

import CoinPython as Inventor

import HEPVis

onx_main = None
if OnX.session() == None:  # Start from scratch (for exa from the Python shell)
  import OnX
  onx_main = OnX.run(0,0) # Create the ONXFILE UI but do not ui.steer.
  ui = OnX.session().ui()
  ui.currentPage().currentRegion().clear()  # To clear the OnX banner.
 
soPage = OnX.session().ui().currentPage()
soPage.title.setValue("OnX/Cube")

soRegion = soPage.currentRegion()
soRegion.color.setValue(Inventor.SbColor(0,0,0))
soSep = soRegion.cast_SoDisplayRegion().getStaticScene()

soCube = Inventor.SoCube() # will ref the C++ node.
soCube.width.setValue(4)

soSep.addChild(soCube)

del soCube # will unref the C++ node.
del soSep
del soRegion
del soPage

if onx_main != None:
  ui.show()
  ui.steer()
  del onx_main
