#
# Put something in the UI tree widget.
#
# This script could be executed on an OnX Python callback ;
# for example on a MenuItem with :
#    <activate exec="Python">import OnX;OnX.x('OnX_exa_tree')</activate>
# or from the OnX UI Python prompt with :
#   Python> import OnX_exa_tree
# or from the python shell with :
#       OS> <setup OnX>
#       OS> <start Python>
#       >>> import OnX_exa_tree
#

import OnX
import OnX as Lib

import HEPVis

onx_main = None
if OnX.session() == None:  # Start from scratch (for exa from the Python shell)
  import OnX
  onx_main = OnX.run(0,0) # Create the ONXFILE UI but do not ui.steer.
  ui = OnX.session().ui()
  ui.currentPage().currentRegion().clear()  # To clear the OnX banner.
 
# Simple test :
#ui.setParameter('mainTree.items','<tree><treeItem><label>Item 1</label></treeItem><treeItem><label>Item 2</label></treeItem></tree>')

file = Lib.fmanip_name("$ONXROOT/scripts/OnX/Tree.xml")
OnX.session().ui().setTreeItems('mainTree',file)

if onx_main != None:
  ui.show()
  ui.steer()
  del onx_main
