#ifndef OnX_DummyUI_h
#define OnX_DummyUI_h 

// Inheritance :
#include <Slash/Core/IManager.h>
#include <Slash/UI/IUI.h>

#include <OnX/Core/CallbackData.h>
namespace Slash {namespace Core {class ISession;}}
namespace Slash {namespace Core {class IWriter;}}
namespace Slash {namespace UI {class IScriptManager;}}

namespace OnX {

class DummyUI : public virtual Slash::UI::IUI {
public: //Slash::UI::IUI :
  virtual void* cast(const std::string&) const;
  virtual void executeScript(const std::string&,const std::string&);
  virtual void put(const std::string&);
  virtual int steer();
  virtual int steerLevel() const;
  virtual void synchronize();
  virtual void exit(int = 0);
  virtual bool lock();
  virtual bool unlock();
  virtual void echo(const std::string&);
  virtual void warn(const std::string&);
  virtual std::string ask(const std::string&);
  virtual void addDispatcher(Slash::UI::IUI::Dispatcher);
  virtual bool removeCallback(const std::string&,
                              const std::string&,
                              int = 0);
  virtual bool setCallback(const std::string&,
                           const std::string&,
                           const std::string&,
                           const std::string&,
                           int = 0);
  virtual void show(const std::string& = "");
  virtual void hide(const std::string& = "");
  virtual bool refresh(const std::string&);
  virtual bool size(const std::string&,unsigned int&,unsigned int&);
  virtual bool position(const std::string&,int&,int&);
  virtual std::string callbackValue();
  virtual const Slash::UI::ICallbackData& callbackData();
  virtual const std::string& thisComponent();
  virtual bool parameterValue(const std::string&,std::string&);
  virtual bool setParameter(const std::string&,const std::string&);
  virtual bool executeCallbacks(const std::string&,const std::string&);
  virtual bool load(const std::string&,const std::string&,bool = true);
  virtual bool save();
  virtual void deleteChildren(const std::string&);
  virtual bool write(const std::string& widget,
                     const std::string& file,
                     const std::string& format,
                     const std::string& options = "");

  virtual Slash::UI::IWidget* findWidget(const std::string&);

  virtual Slash::UI::IWidget* createWidget(
                                const Slash::UI::IWidgetClass& aClass,
                                const std::string& aName,
                                Slash::UI::IWidget& aParent,
                                const std::vector<std::string>& aArgs = std::vector<std::string>());

  virtual bool size(const Slash::UI::IWidget&,unsigned int&,unsigned int&);

  virtual Slash::UI::ICyclic* createCyclic(const std::string&,
                                int,const std::string&,const std::string&);
  virtual Slash::UI::ICyclic* findCyclic(const std::string&) const;
  virtual bool createComponent(const std::string& aName,
                               const std::string& aClass,
                               const std::string& aParent);
  virtual bool copyComponent(const std::string&,
                             const std::string&,
                             const std::string&);
  virtual std::vector<std::string> findChildren(const std::string&,
                                                const std::string&,
                                                const std::string&) const;
  virtual bool destroyComponent(const std::string&);
  virtual bool isComponent(const std::string&);
  virtual Slash::Core::ISession& session();
  virtual bool beingDestroyed() const;
  virtual bool finalize();

  virtual bool isValid() const;
  virtual bool setCallbackData(const Slash::UI::ICallbackData&);
  virtual std::string createWidgetName();
  virtual Slash::UI::IWidgetClass* findWidgetClass(const std::string&) const;
  virtual Slash::UI::IWidget* currentWidget() const; 
  virtual bool setCurrentWidget(Slash::UI::IWidget*); 
  virtual bool enableTerminal(const std::string&,const std::string&);
  virtual bool disableTerminal();
  virtual bool redirectAskToTerminal(bool); 
public: //Lib::IAuditor
  virtual bool notify(Slash::Core::IMessage*);
public:
  DummyUI(Slash::Core::ISession&,const std::string&,const std::vector<std::string>&);
  virtual ~DummyUI();
  Slash::Core::IWriter& printer() const;
private:
  Slash::Core::ISession& fSession;
  std::string fName;
  std::string fValue;
  Slash::UI::IScriptManager* fScriptManager;
  CallbackData fCallbackData;
};

}

#endif

