#ifndef OnX_StyleManager_h
#define OnX_StyleManager_h

// Inheritance :
#include <Slash/Core/IManager.h>
#include <Slash/UI/IStyleManager.h>

#include <vector>

namespace Slash {namespace Core {class ISession;}}

namespace OnX {

class StyleManager : public virtual Slash::Core::IManager, public virtual Slash::UI::IStyleManager {
public: //Slash::Core::IManager
  virtual std::string name() const;
  virtual void* cast(const std::string&) const;
public: //Slash::UI::IStyleManager
  virtual bool isStyle(const std::string&) const;
  virtual bool findStyle(const std::string&,std::string&) const;
  virtual bool loadFile(const std::string&);
  virtual std::vector<std::string> styles() const;
public:
  StyleManager(Slash::Core::ISession&);
  virtual ~StyleManager();
private:
  Slash::Core::ISession& fSession;
  std::string fName;
  std::vector< std::pair<std::string,std::string> > fList;
};

}

#endif
