#ifndef OnX_QtTools_h
#define OnX_QtTools_h 

#include <string>
#include <vector>

namespace Slash {namespace Core {class IWriter;}}

#include <qnamespace.h>

class QString;
class QWidget;
class QComboBox;
class QDialog;

#if QT_VERSION < 0x040000
class QHBox;
class QVBox;
class QButton;
class QListViewItem;
#else
#ifdef QT3_SUPPORT
class Q3HBox;
class Q3VBox;
class Q3Button;
class Q3ListViewItem;
#define QHBox Q3HBox
#define QVBox Q3VBox
#define QButton Q3Button
#define QListViewItem Q3ListViewItem
#else
#error "OnX on Qt4 without -DQT3_SUPPORT not yet supported."
#endif
#endif

class QCallbackData {
public:
  QCallbackData():x(0),y(0){}
public:
  std::string value;
  std::string event;
  int x;
  int y;  
};

namespace OnX {

std::string q2std(const QString&);
Qt::WFlags decorationFlags(const std::vector< std::pair<bool,std::string> >&,
                           Slash::Core::IWriter&);
int QWidgetGetNumberOfChildren(QWidget&);
void QWidgetSetForeground(QWidget&,const std::string&);
void QWidgetSetBackground(QWidget&,const std::string&);
void QComboBoxSetBackground(QComboBox&,const std::string&);

void QButtonSetBackground(QButton&,const std::string&);
bool QHBoxSetExpand(QHBox&,const std::string&);
bool QVBoxSetExpand(QVBox&,const std::string&);
std::string QListViewItemGetPath(QListViewItem*);
std::string QListViewItemGetXML(QListViewItem*);

void QDialogDisableEnter(QDialog&);

}

#if QT_VERSION < 0x040000
#else
#undef QHBox
#undef QVBox
#undef QButton
#undef QListViewItem
#endif

#endif

